/*
    Copyright (c) 2010, 2011 aizo ag, Zurich, Switzerland

    Author: Sergey 'Jin' Bostandzhyan <jin@dev.digitalstrom.org>

    This file is part of dS Assistant.

    dS-Assistant is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dS-Assistant is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

    NOTE: all APIs, especially the JSON API, offered by this application
          are subject to change without further notice.
*/

#ifndef __DSA_JSON_HARDWARE_WEB_HANDLER_H__
#define __DSA_JSON_HARDWARE_WEB_HANDLER_H__

#include "json_web_handler.h"

namespace dSA
{

class JSONHardwareWebHandler : public JSONWebHandler
{
public:
    JSONHardwareWebHandler(struct mg_connection* connection,
                   const struct mg_request_info* request_info);
    virtual void process();
private:
    std::string get();

    std::string getApartmentId();
    std::string setApartmentId();
    std::string getMeterProgrammingModeFlag();
    std::string setMeterProgrammingModeFlag();
    std::string getMeterLedModeFlag();
    std::string setMeterLedModeFlag();

    std::string testDeviceTransmissionQuality();
    std::string testDevicePresence();
    std::string testDeviceStatistic(int mode);
    std::string testMeterStatistic(int mode);
    std::string testSystemMonitor();
};

}; // namespace

#endif//__DSA_JSON_HARDWARE_WEB_HANDLER_H__

